--Custom Signpost Frame

freeslot(
	"SPR_PRIB",
	"SPR_PEMR",
	"SPR_PBSE",
	"MT_PODIUMBASE",
	"S_PODIUMBASE",
	"MT_PODIUMRIBBON",
	"S_PODIUMRIBBON",
	"MT_SIGNEMERALD",
	"S_SIGNEMERALD"
)

-- Copying info from MT_OVERLAY in source; just need this to have a different
-- DispOffset so it's drawn over everything else
mobjinfo[MT_PODIUMRIBBON] = {
	-1,             // doomednum
	S_NULL,         // spawnstate
	1,              // spawnhealth
	S_NULL,         // seestate
	sfx_None,       // seesound
	0,              // reactiontime
	sfx_None,       // attacksound
	S_NULL,         // painstate
	3,              // painchance
	sfx_None,       // painsound
	S_NULL,         // meleestate
	S_NULL,         // missilestate
	S_NULL,         // deathstate
	S_NULL,         // xdeathstate
	sfx_None,       // deathsound
	0,              // speed
	1*FRACUNIT,     // radius
	1*FRACUNIT,     // height
	2,              // display offset
	1000,           // mass
	8,              // damage
	sfx_None,       // activesound
	MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY|MF_DONTENCOREMAP, // flags
	S_NULL          // raisestate
}
states[S_PODIUMRIBBON] = {
	sprite = SPR_PRIB,
	frame = A,
	tics = -1,
	var1 = 0,
	var2 = 0
}

mobjinfo[MT_SIGNEMERALD] = {
	-1,             // doomednum
	S_NULL,         // spawnstate
	1,              // spawnhealth
	S_NULL,         // seestate
	sfx_None,       // seesound
	0,              // reactiontime
	sfx_None,       // attacksound
	S_NULL,         // painstate
	3,              // painchance
	sfx_None,       // painsound
	S_NULL,         // meleestate
	S_NULL,         // missilestate
	S_NULL,         // deathstate
	S_NULL,         // xdeathstate
	sfx_None,       // deathsound
	0,              // speed
	1*FRACUNIT,     // radius
	1*FRACUNIT,     // height
	3,              // display offset
	1000,           // mass
	8,              // damage
	sfx_None,       // activesound
	MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY|MF_DONTENCOREMAP, // flags
	S_NULL          // raisestate
}
states[S_SIGNEMERALD] = {
	sprite = SPR_PEMR,
	frame = A,
	tics = -1,
	var1 = 0,
	var2 = 0
}

mobjinfo[MT_PODIUMBASE] = {
	-1,             // doomednum
	S_NULL,         // spawnstate
	1,              // spawnhealth
	S_NULL,         // seestate
	sfx_None,       // seesound
	0,              // reactiontime
	sfx_None,       // attacksound
	S_NULL,         // painstate
	3,              // painchance
	sfx_None,       // painsound
	S_NULL,         // meleestate
	S_NULL,         // missilestate
	S_NULL,         // deathstate
	S_NULL,         // xdeathstate
	sfx_None,       // deathsound
	0,              // speed
	1*FRACUNIT,     // radius
	1*FRACUNIT,     // height
	2,              // display offset
	1000,           // mass
	8,              // damage
	sfx_None,       // activesound
	MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY|MF_DONTENCOREMAP, // flags
	S_NULL          // raisestate
}
states[S_PODIUMBASE] = {
	sprite = SPR_PBSE,
	frame = A,
	tics = -1,
	var1 = 0,
	var2 = 0
}


local ribboncolor = {
	A,
	B,
	C
}

rawset(_G, "sp_participationtrophy" , CV_RegisterVar({
	name = "sp_participationtrophy",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

local signpodium = {
	SKINCOLOR_MUSTARD,
	SKINCOLOR_SILVER,
	SKINCOLOR_CINNAMON
}

local superpodium = {
	[1] = 	{SKINCOLOR_SUPER1,
			SKINCOLOR_SUPER2,
			SKINCOLOR_SUPER3,
			SKINCOLOR_SUPER4,
			SKINCOLOR_SUPER5},

	[2] = 	{SKINCOLOR_WSUPER1,
			SKINCOLOR_WSUPER2,
			SKINCOLOR_WSUPER3,
			SKINCOLOR_WSUPER4,
			SKINCOLOR_WSUPER5},

	[3] = 	{SKINCOLOR_TSUPER1,
			SKINCOLOR_TSUPER2,
			SKINCOLOR_TSUPER3,
			SKINCOLOR_TSUPER4,
			SKINCOLOR_TSUPER5},

	[4] = 	{SKINCOLOR_KSUPER1,
			SKINCOLOR_KSUPER2,
			SKINCOLOR_KSUPER3,
			SKINCOLOR_KSUPER4,
			SKINCOLOR_WSUPER5,
			SKINCOLOR_TSUPER1,
			SKINCOLOR_TSUPER2,
			SKINCOLOR_TSUPER3,
			SKINCOLOR_TSUPER4,
			SKINCOLOR_WSUPER5,
			SKINCOLOR_SUPER1,
			SKINCOLOR_SUPER2,
			SKINCOLOR_SUPER3,
			SKINCOLOR_SUPER4,
			SKINCOLOR_WUPER5,
			SKINCOLOR_GSUPER1,
			SKINCOLOR_GSUPER2,
			SKINCOLOR_GSUPER3,
			SKINCOLOR_GSUPER4,
			SKINCOLOR_WSUPER5,
			SKINCOLOR_ASUPER1,
			SKINCOLOR_ASUPER2,
			SKINCOLOR_ASUPER3,
			SKINCOLOR_ASUPER4,
			SKINCOLOR_WSUPER5,
			SKINCOLOR_BSUPER1,
			SKINCOLOR_BSUPER2,
			SKINCOLOR_BSUPER3,
			SKINCOLOR_BSUPER4,
			SKINCOLOR_WSUPER5,
			SKINCOLOR_PSUPER1,
			SKINCOLOR_PSUPER2,
			SKINCOLOR_PSUPER3,
			SKINCOLOR_PSUPER4,
			SKINCOLOR_WSUPER5}
}

local podiumscale = {
	[1] = {1, 1},
	[2] = {3, 4},
	[3] = {1, 2}
}

local memescale = {
	[1] = {1, 1},	
	[2] = {31, 32},	
	[3] = {15, 16},
	[4] = {29, 32},
	[5] = {7, 8},
	[6] = {27, 32},
	[7] = {13, 16},
	[8] = {25, 32},
	[9] = {3, 4},
	[10] = {23, 32},
	[11] = {11, 16},
	[12] = {21, 32},
	[13] = {5, 8},
	[14] = {19, 32},
	[15] = {9, 16},
	[16] = {17, 32}
}

local function sp_SparkleMaker(mo)
	local r = (mo.radius/FRACUNIT)*4
	local z = (P_RandomKey((mo.height/FRACUNIT)*2)*FRACUNIT)
	local shiny = P_SpawnMobj(mo.x + (P_RandomRange(r, -r)*FRACUNIT), mo.y + (P_RandomRange(r, -r)*FRACUNIT), mo.z + z, MT_SPARKLETRAIL)
	shiny.target = mo
	shiny.color = mo.color
end

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid and mo.target.player) then return end

	local p = mo.target.player
	
	if not mo.spflagset then
		mo.spgrow = p.mo.spgrowfinish
		mo.spinv = p.mo.spinvfinish
		mo.spsuper = p.hqsuperfinish
		mo.spflagset = true
	end

	if mo.spsuper then
		if not mo.scycleset then
			mo.spodcycle = 1
			mo.scycleset = true
		end
		
		if leveltime%3 == 0 then
			if sp_participationtrophy.value then
				if p.kartstuff[k_position] < 4 then
					if mo.spodcycle >= #HQ_animSuper[p.kartstuff[k_position]] then
						mo.spodcycle = 1
					else
						mo.spodcycle = $ + 1
					end
				else
					if mo.spodcycle >= #HQ_animSuper[p.mo.hqsupernumber]
					and #HQ_animSuper[p.mo.hqsupernumber] then
						mo.spodcycle = 1
					else
						mo.spodcycle = $ + 1
					end
				end
			else
				if mo.spodcycle >= #superpodium[p.kartstuff[k_position]] then
					mo.spodcycle = 1
				else
					mo.spodcycle = $ + 1
				end
			end
		end
		if sp_participationtrophy.value then
			if p.kartstuff[k_position] < 4 then
				mo.color = superpodium[p.kartstuff[k_position]][mo.spodcycle]
			else
				mo.color = HQ_animSuper[p.mo.hqsupernumber][mo.spodcycle]
			end
		else
			mo.color = superpodium[p.kartstuff[k_position]][mo.spodcycle]
		end
	elseif mo.spinv then
		if not mo.icycleset then
			mo.ipodcycle = 1
			mo.icycleset = true
		end

		if superpodium[4][mo.ipodcycle] ~= nil then --What the fuck.
			mo.color = superpodium[4][mo.ipodcycle]
		end
		
		sp_SparkleMaker(mo)
		sp_SparkleMaker(mo)
		sp_SparkleMaker(mo)

		if leveltime % 3 == 0 then
			if mo.ipodcycle >= #superpodium[4] then
				mo.ipodcycle = 1
			else
				mo.ipodcycle = $ + 1
			end
		end
	elseif mo.spgrow then
		mo.color = SKINCOLOR_PERIWINKLE
	else
		if sp_participationtrophy.value then
			if p.kartstuff[k_position] <= 3 then
				mo.color = signpodium[p.kartstuff[k_position]]
			else
				if not mo.spcolorset
					mo.spstoredcolor = p.skincolor
					mo.spcolorset = true
				end

				mo.color = mo.spstoredcolor
			end
		else
			mo.color = signpodium[p.kartstuff[k_position]]
		end
	end

end, MT_SIGN)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
		
	if mo.target
	and mo.target.valid
	and mo.target.player then
		local p = mo.target.player
		
		if not mo.spflagset then
			mo.spgrow = p.mo.spgrowfinish
			mo.spinv = p.mo.spinvfinish
			mo.spsuper = p.hqsuperfinish
			mo.spflagset = true
		end

		if sp_participationtrophy.value then
			if p.kartstuff[k_position] <= #memescale then
				mo.scale = ((memescale[p.kartstuff[k_position]][1])*mapobjectscale)/(memescale[p.kartstuff[k_position]][2])
			else
				mo.scale = mapobjectscale/2
			end
		else
			mo.scale = ((podiumscale[p.kartstuff[k_position]][1])*mapobjectscale)/(podiumscale[p.kartstuff[k_position]][2])
		end
		
		if not mo.spscaleset then
			mo.spstoredscale = mo.scale
			mo.spscaleset = true
		end

		if mo.spgrow then
			mo.scale = (mo.spstoredscale*3)/2
			if mo.eflags & MFE_JUSTHITFLOOR and not P_CheckDeathPitCollide(mo) then
				if abs(mo.spprevmomz) > mo.momz then
					if not mo.spquakesound
						S_StartSound(mo, sfx_s1cb)
						mo.spquakesound = true
					end
					if not mo.spquake then
						for x in players.iterate
							if not x.exiting then continue end
							if not splitscreen and x == displayplayers[0] then
								P_StartQuake(40<<FRACBITS, 6)
							end
						end
						mo.spquake = true
					end
				end
			end
			
			if not mo.spbaseset
				local base = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PODIUMBASE)
				base.target = mo
				base.state = S_PODIUMBASE
				base.scale = mo.scale
				
				mo.spbaseset = true
			end
			
			mo.spprevmomz = mo.momz
		else
			mo.scale = mo.spstoredscale
			-- You ever see a signpost change size after someone spec's?
			-- Shit is hilarious
		end
		
		-- Spawn Ribbon and Emerald overlays
		
		if mo.eflags & MFE_JUSTHITFLOOR and not P_CheckDeathPitCollide(mo) then
			
			if (p.kartstuff[k_position] >=1 and p.kartstuff[k_position] <= 3)
			or (mo.spsuper or mo.spgrow or mo.spinv) then
				if not mo.spribbonset then
					local ribbon = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PODIUMRIBBON)
					ribbon.target = mo
					ribbon.state = S_PODIUMRIBBON
					ribbon.frame = ribboncolor[min(p.kartstuff[k_position], 3)]
				
					if p.kartstuff[k_position] >= 4 then
						ribbon.color = p.skincolor
					end
					
					ribbon.scale = mo.scale
				
					mo.spribbonset = true
				end
			end
			
			if mo.spsuper
			and not mo.spemeraldset then
				local emerald = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SIGNEMERALD)
				emerald.target = mo
				emerald.state = S_SIGNEMERALD
				emerald.scale = mo.scale/2
				mo.spemeraldset = true
				--print("Emerald spawned.")
			end
			
		end
	end
end, MT_SIGN)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
		
	if (mo.target and mo.target.valid)
	and (mo.target.target and mo.target.target.valid and mo.target.target.player) then
		if mo.spstoredscale ~= nil then
			mo.scale = mo.spstoredscale
		end
	end
end, MT_OVERLAY)

local chasers = {MT_PODIUMRIBBON, MT_SIGNEMERALD, MT_PODIUMBASE}

for _, i in ipairs(chasers) do
	addHook("MobjThinker", function(mo)
		if not (mo and mo.valid) then return end
		if not (mo.target and mo.target.valid) then return end
	
		if mo.target.target
		and mo.target.target.valid
		and mo.target.target.player then
			A_CapeChase(mo)
		end

	end, i)
end

addHook("ThinkFrame", function()
	if leveltime == 0 then return end
	
	for p in players.iterate
		if p.exiting then
			p.spsigndelay = $ + 1
			p.spsigndelay = min($, (TICRATE/5)+1)
			if p.kartstuff[k_growshrinktimer] > 0
			or (HugeQuest and p.hugequest.huge) then
				p.mo.spgrowfinish = true
			end
			
			if p.kartstuff[k_invincibilitytimer]
			and not (HugeQuest and p.hugequest.super) then
				p.mo.spinvfinish = true
			end
			
			if p.spsigndelay == (TICRATE/5) then
				if (p.kartstuff[k_position] > 1 and sp_participationtrophy.value)
				or ((p.kartstuff[k_position] > 1 and p.kartstuff[k_position] < 4) and not sp_participationtrophy.value)then
					if not p.mo.signspawned then
						local exitsign = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z+(mapobjectscale*400),MT_SIGN)
						exitsign.target = p.mo
						exitsign.state = S_SIGN1
						exitsign.movefactor = p.mo.floorz
						exitsign.movecount = 1
						p.mo.signspawned = true
					end
				end
			end
		end
	end
end)

local function SP_Init(p)
	p.spsigndelay = 0
end
addHook("PlayerSpawn", SP_Init)